 ; ADF4351 by F5UBZ
 #include "p12f675.inc"

 __CONFIG _FOSC_INTRCIO & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _BOREN_ON & _CP_OFF & _CPD_OFF
 
 ; EEPROM LOCATION 
 
 		ORG	0x2100
		
		DE	0x00, 0x33, 0x82, 0xB8  ; register  R0  1296,200Mhz // ok
		DE	0x08, 0x00, 0x83, 0xE9  ; register  R1  
		DE	0x78, 0x00, 0x5E, 0x42  ; register  R2
		DE	0x00, 0x00, 0x04, 0xB3  ; register  R3
		DE	0x00, 0x9C, 0x82, 0x3C  ; register  R4
		DE	0x00, 0x58, 0x00, 0x05  ; register  R5 		
		
		DE	0x00, 0x2E, 0x03, 0x28  ; register  R0 2320,200Mhz // ok
		DE	0x08, 0x00, 0x83, 0xE9  ; register  R1 
		DE	0x78, 0x00, 0x5E, 0x42  ; register  R2
		DE	0x00, 0x00, 0x04, 0xB3  ; register  R3
		DE	0x00, 0x8C, 0x82, 0x3C  ; register  R4
		DE	0x00, 0x58, 0x00, 0x05  ; register  R5
		
		
	

ADF4351_data	 equ	0x00 	  
ADF4351_LD       equ    0x03 
ADF4351_clk      equ	0x01 
ADF4351_data	 equ	0x00 	
ADF4351_LE       equ    0x02 
select_f1_f2     equ    0x05    
select_mode_cw   equ    0x04  
flag_beacon      equ    0x00 
flag_f1_preset   equ    0x01
flag_f2_preset   equ    0x02
flag_rf_f1_out   equ    0x03
flag_rf_f2_out   equ    0x04


cnt	           equ 40h   ;
count              equ 41h   ;
temp               equ 42h   ;
	       
register_db31_db24 equ 43h   ;
register_db23_db16 equ 44h   ;
register_db15_db8  equ 45h   ;
register_db7_db0   equ 46h   ; 
reg_out            equ 47h   ;
W_TEMP             equ 48h   ;
STATUS_TEMP        equ 49h   ;	     
flag_flip_flop     equ 4Ah   ; 

	 

                org 0
		goto start 
		
		org 4		
traite_interruption                  
		 movwf W_TEMP
		 swapf STATUS,W
		 movwf STATUS_TEMP
    	         btfsc GPIO,select_mode_cw
		 goto cw_mode		 
beacon_mode	 btfss flag_flip_flop,0
		 goto $+4
		 call tx_off
		 bcf flag_flip_flop,0
		 goto $+3		 
		 call tx_on
		 bsf flag_flip_flop,0
		 goto end_interrupt		 
cw_mode          call tx_on_cw	                		
end_interrupt    movlw d'25'
		 movwf TMR1L
		 movlw d'170'
		 movwf TMR1H		 
		 bcf PIR1,TMR1IF		 
		 swapf STATUS_TEMP,W
		 movwf STATUS
		 swapf W_TEMP,F
		 swapf W_TEMP,W
		 retfie
		 
		
start           bcf STATUS,RP0
		clrf GPIO		
		bsf STATUS,RP0
		movlw b'0000000'   
		movwf ANSEL        
		movlw b'00111000'  
		movwf TRISIO       
		movlw b'00110000'
		movwf WPU
		movlw b'01111111'
		movwf OPTION_REG
		bcf STATUS,RP0
		movlw d'7'
		movwf CMCON  			
		bcf GPIO,ADF4351_clk 	
		bcf GPIO,ADF4351_data
		bcf GPIO,ADF4351_LE
		bsf GPIO,ADF4351_LE
		bcf GPIO,ADF4351_LE		
		call wait_2ms	
		clrf flag_flip_flop
		call preset_f1
		call rf_on_f1
		call wait_2ms							
		movlw d'240'
		movwf TMR1L
		movlw d'255'
		movwf TMR1H
		movlw b'00110101'
		movwf T1CON ; config timer1 
		bsf STATUS,RP0
	        bsf PIE1,TMR1IE
		bcf STATUS,RP0
		bsf INTCON, PEIE 
		bsf INTCON,GIE		
		clrf flag_flip_flop
		
;*********** Main_loop^********************
main_loop	goto $ 	
;******************************************		
		
tx_on_cw	btfsc GPIO,select_f1_f2 
		goto $+4
		call preset_f2		
		call rf_on_f2
		return
		call preset_f1
		call rf_on_f1
		return	
     	
tx_on           btfsc GPIO,select_f1_f2 
	        goto $+4
	        call preset_f2
	        call rf_on_f2
	        goto $+3
	        call preset_f1
	        call rf_on_f1
	        return
	       
tx_off          btfsc GPIO,select_f1_f2 
	        goto $+4
	        call preset_f2
	        call rf_off_f2
	        goto $+3
	        call preset_f1
	        call rf_off_f1
	        return          	 	
		
preset_f1       btfsc flag_flip_flop,flag_f1_preset
	        return
	        movlw d'20'		
		call eeprom_read
		movwf register_db31_db24
		movlw d'21'
		call eeprom_read
		movwf register_db23_db16
		movlw d'22'
		call eeprom_read
		movwf register_db15_db8
		movlw d'23'
		call eeprom_read
		movwf register_db7_db0   ; register #5		
		call output_register		
		movlw d'16'
		call eeprom_read
		movwf register_db31_db24
		movlw d'17'
		call eeprom_read
		movwf register_db23_db16
		movlw d'18'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'19'
		call eeprom_read
		movwf register_db7_db0   ; register #4	
		call output_register		
		movlw d'12'
		call eeprom_read
		movwf register_db31_db24
		movlw d'13'
		call eeprom_read
		movwf register_db23_db16
		movlw d'14'
		call eeprom_read
		movwf register_db15_db8
		movlw d'15'
		call eeprom_read
		movwf register_db7_db0   ; register #3		
		call output_register		
		movlw d'8'
		call eeprom_read
		movwf register_db31_db24
		movlw d'9'
		call eeprom_read
		movwf register_db23_db16
		movlw d'10'
		call eeprom_read
		movwf register_db15_db8
		movlw d'11'
		call eeprom_read
		movwf register_db7_db0   ; register #2		
		call output_register		
		movlw d'4'
		call eeprom_read
		movwf register_db31_db24
		movlw d'5'
		call eeprom_read
		movwf register_db23_db16
		movlw d'6'
		call eeprom_read
		movwf register_db15_db8
		movlw d'7'
		call eeprom_read
		movwf register_db7_db0   ; register #1
		call output_register		
		movlw d'0'
		call eeprom_read
		movwf register_db31_db24
		movlw d'1'
		call eeprom_read
		movwf register_db23_db16
		movlw d'2'
		call eeprom_read
		movwf register_db15_db8
		movlw d'3'
		call eeprom_read
		movwf register_db7_db0   ; register #0
		call output_register			
		call wait_2ms
		bsf flag_flip_flop,flag_f1_preset
		bcf flag_flip_flop,flag_f2_preset
		return		
		
rf_off_f1	btfss flag_flip_flop,flag_rf_f1_out
		return
		movlw d'16'
		call eeprom_read
		movwf register_db31_db24
		movlw d'17'
		call eeprom_read
		movwf register_db23_db16
		movlw d'18'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'19'
		call eeprom_read
		movwf register_db7_db0   ; register #4	
		bcf register_db7_db0,5			
		call output_register
		call wait_2ms	
		bcf flag_flip_flop,flag_rf_f1_out
		return

rf_on_f1	btfsc flag_flip_flop,flag_rf_f1_out
		return
		movlw d'16'
		call eeprom_read
		movwf register_db31_db24
		movlw d'17'
		call eeprom_read
		movwf register_db23_db16
		movlw d'18'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'19'
		call eeprom_read
		movwf register_db7_db0   ; register #4	
		bsf register_db7_db0,5			
		call output_register	
		call wait_2ms
		bsf flag_flip_flop,flag_rf_f1_out		
		return		

preset_f2	btfsc flag_flip_flop,flag_f2_preset
		return
		movlw d'44'		
		call eeprom_read
		movwf register_db31_db24
		movlw d'45'
		call eeprom_read
		movwf register_db23_db16
		movlw d'46'
		call eeprom_read
		movwf register_db15_db8
		movlw d'47'
		call eeprom_read
		movwf register_db7_db0   ; register #5		
		call output_register		
		movlw d'40'
		call eeprom_read
		movwf register_db31_db24
		movlw d'41'
		call eeprom_read
		movwf register_db23_db16
		movlw d'42'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'43'
		call eeprom_read
		movwf register_db7_db0   ; register #4	
		call output_register		
		movlw d'36'
		call eeprom_read
		movwf register_db31_db24
		movlw d'37'
		call eeprom_read
		movwf register_db23_db16
		movlw d'38'
		call eeprom_read
		movwf register_db15_db8
		movlw d'39'
		call eeprom_read
		movwf register_db7_db0   ; register #3		
		call output_register		
		movlw d'32'
		call eeprom_read
		movwf register_db31_db24
		movlw d'33'
		call eeprom_read
		movwf register_db23_db16
		movlw d'34'
		call eeprom_read
		movwf register_db15_db8
		movlw d'35'
		call eeprom_read
		movwf register_db7_db0   ; register #2		
		call output_register		
		movlw d'28'
		call eeprom_read
		movwf register_db31_db24
		movlw d'29'
		call eeprom_read
		movwf register_db23_db16
		movlw d'30'
		call eeprom_read
		movwf register_db15_db8
		movlw d'31'
		call eeprom_read
		movwf register_db7_db0   ; register #1
		call output_register		
		movlw d'24'
		call eeprom_read
		movwf register_db31_db24
		movlw d'25'
		call eeprom_read
		movwf register_db23_db16
		movlw d'26'
		call eeprom_read
		movwf register_db15_db8
		movlw d'27'
		call eeprom_read
		movwf register_db7_db0   ; register #0
		call output_register			
		call wait_2ms	
		bcf flag_flip_flop,flag_f1_preset
		bsf flag_flip_flop,flag_f2_preset		
		return
		
rf_on_f2	btfsc flag_flip_flop,flag_rf_f2_out
		return
		movlw d'40'
		call eeprom_read
		movwf register_db31_db24
		movlw d'41'
		call eeprom_read
		movwf register_db23_db16
		movlw d'42'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'43'
		call eeprom_read
		movwf register_db7_db0   ; register #4		
		bsf register_db7_db0,5	
		call output_register
		call wait_2ms
		bsf flag_flip_flop,flag_rf_f2_out		
		return
		
rf_off_f2	btfss flag_flip_flop,flag_rf_f2_out
		return
		movlw d'40'
		call eeprom_read
		movwf register_db31_db24
		movlw d'41'
		call eeprom_read
		movwf register_db23_db16
		movlw d'42'
		call eeprom_read
		movwf register_db15_db8	
		movlw d'43'
		call eeprom_read
		movwf register_db7_db0   ; register #4		
		bcf register_db7_db0,5	
		call output_register
		call wait_2ms
		bcf flag_flip_flop,flag_rf_f2_out
		return
		
eeprom_read  	bsf STATUS,RP0
		movwf EEADR
		bsf EECON1,RD
		movf EEDATA,W
		bcf STATUS,RP0
                return			
	

output_register  movf register_db31_db24,0
		 movwf reg_out		
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk			   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   	   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk	
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   	   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		movf register_db23_db16,0
		movwf reg_out		
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk	 		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk	  
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		movf register_db15_db8,0
		movwf reg_out		
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk	   		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk	
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		movf register_db7_db0,0
		movwf reg_out		
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk			   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk	
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk		   
		rlf reg_out,1
		btfss STATUS,C
		goto $+3
		bsf GPIO,ADF4351_data
		goto $+2
		bcf GPIO,ADF4351_data
		bsf GPIO,ADF4351_clk
		bcf GPIO,ADF4351_clk
		bsf GPIO,ADF4351_LE 
		bcf GPIO,ADF4351_LE 
		return
			
			
wait_2ms        movlw	D'4'	 
                movwf   count    
outer_loop                        
	        movlw	H'A4'		
	        movwf	temp
inner_loop
	        decfsz	temp,f		
	        goto	inner_loop				
	        decfsz	count,f		
	        goto	outer_loop				
	        return			

		
		END
		